(function() {
	'use strict';

	const thisScript = document.scripts[document.scripts.length - 1];
	const urlBase = thisScript.src.replace(/[^/]*\.js$/, '');
	const pluginClass = urlBase.replace(/.*\/([\w-]+)\/?$/, '$1');

	// test jQuery
	if(typeof jQuery !== 'function') {
		const myScript = document.createElement('SCRIPT');
		myScript.type = 'text/javascript';
		myScript.src =  urlBase + thisScript.dataset.src;
		myScript.onload = function() {
			console.log(thisScript.dataset.src + ' loaded');
		};
		document.head.appendChild(myScript);
	}

	hljs.initHighlightingOnLoad();

	var timer1 = null;

	function copyCode(event) {
		event.preventDefault();
		const range = document.createRange();
		const selection = window.getSelection();
		selection.removeAllRanges();
		const el = event.target;
		range.selectNode(el.code);
		selection.addRange(range);
		try {
			const result = document.execCommand('copy');
			if(result) {
				el.classList.add('copied');
				timer1 = setTimeout(function() {
					el.classList.remove('copied');
					clearTimeout(timer1);
				}, 5000);
			}
		} catch(err) {
			alert(err);
		}
		if(typeof selection.removeRange == 'function') {
			selection.removeRange(range);
		} else if(typeof selection.removeAllRanges == 'function') {
			selection.removeAllRanges(range);
		}
	}

	// Button "copy" to the clipboard
	const areas = document.querySelectorAll('pre > code');
	for(var i=0, iMax=areas.length; i<iMax; i++) {
		const btn = document.createElement('BUTTON');
		btn.type = 'button';
		btn.className = pluginClass + '-copy';
		btn.textContent = 'copy';
		btn.code = areas[i];
		btn.addEventListener('click', copyCode);
		const preformat = areas[i].parentNode;
		preformat.parentNode.insertBefore(btn, preformat);
	}
})();
